	list	p=16F84
	#include p16F84.inc
;1
	__CONFIG  _XT_OSC&_WDT_OFF
COMPT1	EQU	H'000C'
COMPT1T	EQU	H'000D'
COMPT2	EQU	H'000E'
COMPT3	EQU	H'000F'
VOIE3	EQU	H'0010'
COMPT_IMPD	EQU	H'0011'
COMPT_IMPG	EQU	H'0012'
I	EQU	H'0013'
VARIF	EQU	H'0014'
VBFOR1	EQU	H'0015'
VBFOR2	EQU	H'0016'
VBFOR3	EQU	H'0017'
;2
	ORG 0
;3
	BSF STATUS, RP0
	MOVLW	H'0F'
	MOVWF	TRISA
	MOVLW	H'0F'
	MOVWF	TRISB
	BCF OPTION_REG,7
	BCF STATUS, RP0
	MOVLW	H'00'
	MOVWF	PORTB
	MOVLW	H'96'
	MOVWF	COMPT3
	BCF PORTA,4
	MOVLW	H'00'
	MOVWF	VOIE3
DEBUT	NOP
;4
; DTERMINATION DES 2 LARGEURS D'IMPULSIONS ENTRANTES
; VOIE 1
ATT11	BTFSS PORTA,2
	GOTO	ATT11
	MOVLW	H'00'
	MOVWF	COMPT1
ATT10	BTFSS PORTA,2
	GOTO	ATT21
	CALL	CY_5
	INCF COMPT1,1
	GOTO	ATT10
; VOIE 2
ATT21	BTFSS PORTA,3
	GOTO	ATT21
	MOVLW	H'00'
	MOVWF	COMPT2
ATT20	BTFSS PORTA,3
	GOTO	FIN_ATT
	CALL	CY_5
	INCF COMPT2,1
	GOTO	ATT20
FIN_ATT	MOVF	COMPT1,0
	SUBLW	H'B4'
	BTFSC	STATUS,C
	GOTO	ELSE1
	BSF VOIE3,0
	MOVLW	H'00'
	MOVWF	COMPT_IMPD
	BTFSC VOIE3,1
	BCF VOIE3,2
ELSE1	NOP
	MOVF	COMPT1,0
	MOVWF	VARIF
	MOVLW	H'78'
	SUBWF	VARIF,0
	BTFSC	STATUS,C
	GOTO	ELSE2
	BSF VOIE3,1
	MOVLW	H'00'
	MOVWF	COMPT_IMPG
	BTFSC VOIE3,0
	BSF VOIE3,2
ELSE2	NOP
	INCF COMPT_IMPD,1
	INCF COMPT_IMPG,1
	BTFSC	COMPT_IMPD,3
	BCF VOIE3,0 
	BTFSC	COMPT_IMPG,3
	BCF VOIE3,1 
	BTFSC VOIE3,2
	GOTO	V3_ON
	MOVLW	H'BE'
	MOVWF	COMPT3
	BTFSC PORTB,3
	BCF PORTA,4
	BTFSS PORTB,3
	BSF PORTA,4
	GOTO	SW1
V3_ON	MOVLW	H'6E'
	MOVWF	COMPT3
	BTFSS PORTB,3
	BCF PORTA,4
	BTFSC PORTB,3
	BSF PORTA,4
;5	
; ACTION SUIVANT TAT DES SWITCHS
; SWITCH1, INV VOIE 1 
SW1	BTFSC PORTB,0
	GOTO	SW2
	MOVLW	H'96'
	SUBWF	COMPT1,0
	MOVWF	COMPT1
	MOVF	COMPT1,0
	SUBLW	H'96'
	MOVWF	COMPT1
; SWITCH2, INV VOIE 2 
SW2	BTFSC PORTB,1
	GOTO	SW3
	MOVLW	H'96'
	SUBWF	COMPT2,0
	MOVWF	COMPT2
	MOVF	COMPT2,0
	SUBLW	H'96'
	MOVWF	COMPT2
; SWITCH3, MIXAGE OU PAS MIXAGE 
SW3	BTFSC PORTB,2
	GOTO	SW4
	BCF STATUS,C
	RRF COMPT1,1
	BCF STATUS,C
	RRF COMPT2,1
	MOVF	COMPT1,0
	ADDWF	COMPT2,0
	MOVWF	COMPT1T
	MOVF	COMPT2,0
	SUBWF	COMPT1,0
	MOVWF	COMPT2
	MOVLW	H'96'
	ADDWF	COMPT2,0
	MOVWF	COMPT2
	MOVF	COMPT1T,0
	MOVWF	COMPT1
SW4	BTFSC PORTB,3
	GOTO	SORTIES
	MOVLW	H'96'
	SUBWF	COMPT3,0
	MOVWF	COMPT3
	MOVF	COMPT3,0
	SUBLW	H'96'
	MOVWF	COMPT3
;6
SORTIES	MOVLW	H'00'
	MOVWF	I
	SUBWF	COMPT1,0
	MOVWF	VBFOR1
	INCF	VBFOR1,1
SP_FOR1	NOP
	BSF PORTB,4	
	CALL	CY_4
	INCF	I,1
	DECFSZ	VBFOR1,1
	GOTO	SP_FOR1
	BCF PORTB,4
	MOVLW	H'00'
	MOVWF	I
	SUBWF	COMPT2,0
	MOVWF	VBFOR2
	INCF	VBFOR2,1
SP_FOR2	NOP
	BSF PORTB,5	
	CALL	CY_4
	INCF	I,1
	DECFSZ	VBFOR2,1
	GOTO	SP_FOR2
	BCF PORTB,5
	MOVLW	H'00'
	MOVWF	I
	SUBWF	COMPT3,0
	MOVWF	VBFOR3
	INCF	VBFOR3,1
SP_FOR3	NOP
	BSF PORTB,6	
	CALL	CY_4
	INCF	I,1
	DECFSZ	VBFOR3,1
	GOTO	SP_FOR3
	BCF PORTB,6
	GOTO	DEBUT
;7
CY_5	NOP
CY_4	RETURN
	NOP
	END
